/*
	NRob Library
		NRob プログラム表示関係のプログラム
*/
//v361	20221207	ループ命令の追加 JLQ,JLS,JLB,JLE
//v361b	ライブラリ統合
//v363	20230114	SW入力　センサーS0に追加

#include "NRobDisp.h"

//****  表示用テーブル   **********************************

//------    メニュー表示上   --------------------
const PROGMEM byte modeStr1[80]={
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbe,0xdd,0xc0,0xb8,0x20,0x20,0x20,0x20,//select
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbe,0xdd,0xc0,0xb8,0x20,0x20,0x20,0x20,//select
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbe,0xdd,0xc0,0xb8,0x20,0x20,0x20,0x20,//select
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbc,0xdd,0xb7,0x20,0x20,0x20,0x20,0x20,//select
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbc,0xad,0xb3,0xbe,0xb2,0x20,0x20,0x20,//select
  };
//------    メニュー表示下   --------------------
const PROGMEM byte modeStr2[80]={
  0x20,0x4d,0x4f,0x44,0x45,0x20,0x20,0xd3,0xb0,0xc4,0xde,0x20,0x20,0x20,0x20,0x20,//モード
  0x20,0x41,0x43,0x54,0x49,0x4f,0x4e,0x20,0xc4,0xde,0xb3,0xbb,0x20,0x20,0x20,0x20,//ドウサ
  0x20,0x53,0x45,0x4e,0x53,0x4f,0x52,0x20,0xbe,0xdd,0xbb,0xb0,0x20,0x20,0x20,0x20,//センサー
  0x20,0x50,0x52,0x4f,0x47,0x52,0x41,0x4d,0xcc,0xdf,0xdb,0xb8,0xde,0xd7,0xd1,0x20,//プログラム
  0x20,0x50,0x52,0x4f,0x47,0x52,0x41,0x4d,0xcc,0xdf,0xdb,0xb8,0xde,0xd7,0xd1,0x20,//プログラム
  };
//---	LCDタイトル	--	LCD_printF(char *w)	--------v361
const char titlWit[] PROGMEM = {"WAIT"};
const char titlMon1[] PROGMEM = {"S1-- S2-- S3--  "};
const char titlMon2[] PROGMEM = {"S4-- S5-- S6--  "};
const char titlMon3[] PROGMEM = {"US S7 --  :"};
const char titlMon4[] PROGMEM = {"US S8 --  :"};
const char titlMon5[] PROGMEM = {"COMPASS a --    "};
const char titlMon6[] PROGMEM = {"COMPASS b --    "};
const char titlMon7[] PROGMEM = {"Servo M3  --    "};
const char titlMon8[] PROGMEM = {"Servo M4  --    "};
const char titlMon9[] PROGMEM = {"Waiting PC      "};

//---	FRAMテーブル	----	動作判定用	------------v361
//0:no/1:数字/2:+変数/3:+-/4:判定/5:XT/6:SCXTI/7:NB/8:演算
	//byte	Atbl[14][10]=	{																
	const char Atbl[140] PROGMEM = {
											 'G', 3, 2, 1, 3, 2, 1, 0, 2, 1,	//G:+30+30:10
											 'M', 3, 2, 1, 3, 2, 1, 0, 0, 0,	//M:+30+30
											 'V', 1, 0, 2, 1, 0, 0, 0, 0, 0,	//V1:50
											 'L', 1, 0, 2, 1, 0, 0, 0, 0, 0,	//L1:01
											 'O', 1, 0, 3, 2, 1, 0, 0, 0, 0,	//O1:+30
											 'W', 0, 2, 1, 0, 0, 0, 0, 0, 0,	//W:10
											 '?', 6, 1, 4, 3, 2, 1, 0, 0, 0,	//?S1>+50
											 '$', 6, 1, 0, 2, 1, 0, 2, 1, 0,	//$C1:00,50
											 '#', 5, 1, 0, 3, 2, 1, 0, 0, 0,	//#T1=+10
											 'B', 0, 1, 1, 0, 0, 0, 0, 0, 0,	//B:01
											 'J', 7, 0, 1, 1, 0, 0, 0, 0, 0,	//JN:01
											 '#', 5, 1, 0, 2, 1, 8, 2, 1, 0,	//#X1=X2+X3
											 'J', 7, 9, 0, 2, 1, 4, 2, 1, 0,	//JLQ:X1>X2
											 'J', 7, 9, 0, 0, 0, 0, 0, 0, 0};	//JLS:

//---------------------------------------------------------

NRobDsp::NRobDsp(NRob3& nr):rob(nr)
{
}
//------------------------------------------------public
void	NRobDsp::reDraw(byte no,byte prg[])		//プログラム再表示(変換して表示)
{
	byte i;
	
	rob.LCD_clear();
	chg_PrgDsp(0, no-1, prg-5);												//0行目は判定用(表示しない)

	chg_PrgDsp(1, no, prg);														//1,2行は表示用
  for(i=0; i<16; i++) rob.LCD_write(prgDsp[1][i]);
	rob.LCD_setCursor(0,1);
	chg_PrgDsp(2, no+1, prg+5);
  for(i=0; i<16; i++) rob.LCD_write(prgDsp[2][i]);
	
  rob.LCD_noBlink();
  rob.LCD_cursor();

}

//---------------------------------------------------------
//*** 編集動作　カーソル移動時  		********************************************

//------------------------------------------------public
byte	NRobDsp::edit_Moving(void)				//移動動作中
//戻り値：0=変更なし/1=選択モードに/2=挿入削除モードに/3=上へ/4=下にスクロール
{
	byte ans=0;

	if(rob.in_SW(0)){											//Sel SW
		if(is_noEditWord(prgDsp[curY][curX])){		//編集文字でないなら右に
			cursor_MoveRight();
		}else{                      //編集対象なら　文字変更開始
			chgWord = prgDsp[curY][curX];			//変更文字セット
			ans = 1;              						//選択モード
			rob.LCD_blink();									//ブリンク
		}
	}
	if(rob.in_SW(4)){											//Left
		ans=cursor_MoveLeft();								//挿入削除モードへの移行確認
	}
	if(rob.in_SW(3)){											//Right
		cursor_MoveRight();
	}
	if(rob.in_SW(2)){											//Up
		ans=cursor_MoveUp();									//スクロールアップ
	}
	if(rob.in_SW(1)){											//Down
		ans=cursor_MoveDown();								//スクロールダウン
	}
	return ans;
}


//*** 編集動作　変更動作中 		**************************************************
//------------------------------------------------public
byte	NRobDsp::edit_Chging(void)				//変更動作中 戻値:0<>動作終了
											//戻り:1or2=更新行/11or12=コマンドの更新/9=何もせず再表示
{
	byte ans=0;
	byte prWord="";

	if(rob.in_SW(0)){											//Sel SW
		prgDsp[curY][curX]=chgWord;							//変更文字セット
		ans=curY;																//変更する行を返す

		if(is_Command()){												//コマンド文字は入力アシスト v363
			ans+=10;
		}

		cursor_MoveRight();
  }
	if(rob.in_SW(4)){											//Left
		ans=9;																//何もせず終了
		cursor_MoveLeft();
  }
	if(rob.in_SW(3)){											//right
		ans=9;																//何もせず終了
		cursor_MoveRight();
	}
	if(rob.in_SW(2)){											//Up
		select_Com(+1);
	}
	if(rob.in_SW(1)){											//Down
		select_Com(-1);
	}
	return ans;
}

//------------------------------------------------private
void	NRobDsp::select_Com(int i)				//選択文字書換え　コマンド＋その他
{
	byte no=seek_Command();								//命令語探してコマンド番号を得る v363

	if(no==curX ||												//コマンド選択位置なら v363
			nowComNo>=COMNum){								//コマンドない＝コマンド選択
																				//上の行の文字を参照し次のコマンドを選択
		chgWord=get_nextCom(prgDsp[curY-1][curX], i);

	}else{																//コマンド以降
		select_NextArg(no,i);								// 引数選択				v360
  }
	
	rob.LCD_write(chgWord);								//変更文字書換え
	rob.LCD_setCursor(curX,curY-1);
}
//------------------------------------------------private
//*
void	NRobDsp::select_NextArg(int no, int a)	//引数選択  v360
																								//no=コマンド位置/a=変化量
{
	//動作判定用テーブル  0:no/1:数字/2:+変数/3:+-/4:判定/5:XT/6:SCXTI/7:NB/8:演算

	/*
	byte	Atbl[14][10]=	{	
											{'G', 3, 2, 1, 3, 2, 1, 0, 2, 1},	//G:+30+30:10
											{'M', 3, 2, 1, 3, 2, 1, 0, 0, 0},	//M:+30+30
											{'V', 1, 0, 2, 1, 0, 0, 0, 0, 0},	//V1:50
											{'L', 1, 0, 2, 1, 0, 0, 0, 0, 0},	//L1:01
											{'O', 1, 0, 3, 2, 1, 0, 0, 0, 0},	//O1:+30
											{'W', 0, 2, 1, 0, 0, 0, 0, 0, 0},	//W:10
											{'?', 6, 1, 4, 3, 2, 1, 0, 0, 0},	//?S1>+50
											{'$', 6, 1, 0, 2, 1, 0, 2, 1, 0},	//$C1:00,50
											{'#', 5, 1, 0, 3, 2, 1, 0, 0, 0},	//#T1=+10
											{'B', 0, 1, 1, 0, 0, 0, 0, 0, 0},	//B:01
											{'J', 7, 0, 1, 1, 0, 0, 0, 0, 0},	//JN:01
											{'#', 5, 1, 0, 2, 1, 8, 2, 1, 0},	//#X1=X2+X3
											{'J', 7, 9, 0, 2, 1, 4, 2, 1, 0},	//JLQ:X1>X2
											{'J', 7, 9, 0, 0, 0, 0, 0, 0, 0}};//JLS:
	*/
	int i,j;
	char	w;

	i=nowComNo-2;																		//テーブル行計算
	if(i==8){																				// #の時 2列以上で
		if(prgDsp[curY][no+1]=='X')	i=11;							//   XとT切り替える
	}else if(i==10){																// Jの時						v361
		if(prgDsp[curY][no+1]=='L'){									// Loop動作？
			w=prgDsp[curY][no+2]; 
			if(w=='S' || w=='E')	i=13;									// SとEは13
			else									i=12;									// QとBは12
		}
	}
	j=curX-no;																			//テーブル列計算

	if(i<14){																				//コマンドあれば
		w=pgm_read_byte(Atbl+(i*10)+j);//v361
		switch(w){																		//テーブル指示に合わせて

			case 1:																			//	数字変更
				chgWord = get_NextNum_VARI(9,a);
				break;
			case 2:																			//  数字＋変数　切替
				chgWord = get_NextNum_VARI(15,a);					
				break;
			case 3:																			//	+-切替
				if(chgWord=='+')	chgWord='-';
				else							chgWord='+';
				break;
			case 4:																			//  記号切替　判定
				chgWord = get_NextKIGO(0,a);							//   
				break;
			case 5:																			//  XT切替
				chgWord = get_NextVARI(1,a);							//   
				break;
			case 6:																			//  SCXT切替
				chgWord = get_NextVARI(0,a);							//   
				break;
			case 7:																			//	NBL切替 v361
				chgWord = get_nextJump(0,a);
				break;
			case 8:																			//  演算式
				chgWord = get_NextKIGO(2,a);							//   
				break;
			case 9:																			// QSBE切替 v361
				chgWord = get_nextJump(1,a);
		}
	}
}

//*** 	カーソル移動  			****************************************************

//------------------------------------------------private
void	NRobDsp::cursor_MoveRight(void)		//カーソル移動右
//右にプログラムあれば右へ、空白なら上の行の階層レベルまで右に
{
  int n = get_dspLen(curY);							//行の文字数
	seek_Command();												//コマンド文字の場所を探す v363

  if(nowComNo>=COMNum){									//コマンド未入力行
    if(curX<n) curX++;									//文字数+1まで
  }else{																//コマンドある行
    if(curX<(n-1))  curX++;							//文字数まで
  }
	setCursor(curX,curY);
}
//------------------------------------------------private
byte	NRobDsp::cursor_MoveLeft(void)		//カーソル移動左
{
	byte ans=0;
  if(curX<=2){                //一番左の時
    ans=2;										// 行編集に移行
		flgInsDel=9;
  }else{
		curX--;
		setCursor(curX,curY);
  }
	return ans;
}
//------------------------------------------------private
byte	NRobDsp::cursor_MoveUp(void)			//カーソル移動上 
{
	byte ans=0;

  if(curY==2){													//カーソル下なら上に移動
    curY=1;
		adjust_curX();
  }else{																//カーソル上ならスクロールup
		ans=3;
	}
	return ans;
}
//------------------------------------------------private
byte	NRobDsp::cursor_MoveDown(void)		//カーソル移動下
{
	byte ans=0;

  if(curY==2){													//カーソル下ならスクロール
		ans=4;
  }else{																//カーソル上なら下に
    curY=2;
		adjust_curX();
	}
	return ans;
}

//------------------------------------------------public
void	NRobDsp::cursor_Home(void)				//カーソルホームへ
{
	curX=2; curY=1;
	rob.LCD_setCursor(curX,curY-1);
}
//------------------------------------------------public
void	NRobDsp::setCursor(byte x,byte y)	//カーソル位置のセット
{
	if(x<2)	curX=2;
	else		curX=x;
	if(y<1)	curY=1;
	else		curY=y;
	rob.LCD_setCursor(curX,curY-1);
}

//------------------------------------------------private
void	NRobDsp::adjust_curX(void)				//カーソルX文字ある部分のみ移動
{
	byte i = get_dspLen(curY);							//行文字数
	if(curX>i)	curX=i;
	setCursor(curX,curY);
}

//*** 挿入削除モード   		******************************************************
//------------------------------------------------public

byte	NRobDsp::edit_InsDel(void)				//行編集動作中 
			//戻値:0=未動作/9=動作終了/10桁:10=削除/20=挿入/1桁:編集中の行(1=上or2=下)
{
	byte	ans=0;

	if(flgInsDel>1){											//初期表示
		flgInsDel=0;
		dsp_InsDel();
	}

	if(rob.in_SW(0)){											//sel SW   
		if(flgInsDel) ans = 4+(curY-1);	//挿入確定
		else          ans = 2+(curY-1);	//削除確定
  }
	if(rob.in_SW(4) || rob.in_SW(3)){			//Left or Right
    ans = 1;															//キャンセル
	}
  if(rob.in_SW(2) || rob.in_SW(1)){			//Up or Down
		if(flgInsDel)	flgInsDel=0;
		else					flgInsDel=1;
    dsp_InsDel();													//挿入削除表示
  }
	return ans;
}

//------------------------------------------------private
void	NRobDsp::dsp_InsDel(void)					//挿入削除表示
{
byte romDel[]=
		{0x20,0x44,0x65,0x6C,0x20,0xBB,0xB8,0xBC,0xDE,0xAE,0x20,0x20,0x20,0x20};
byte romIns[]=
		{0x20,0x49,0x6E,0x73,0x20,0xBF,0xB3,0xC6,0xAD,0xB3,0x20,0x20,0x20,0x20};

	rob.LCD_noCursor();
	rob.LCD_setCursor(2, curY-1);
	if(flgInsDel){
		for(int i=0; i<14; i++) rob.LCD_write(romIns[i]);
  }else{
		for(int i=0; i<14; i++) rob.LCD_write(romDel[i]);
  }
}
//------------------------------------------------



//*** プログラムデータを表示データに変換　プログラム(参照)->prgDsp  ************

//------------------------------------------------public
byte*	NRobDsp::chg_PrgDsp(byte ln,byte no,byte prg[])		//１行変換
													//１行変換：ln:表示行(0-2)/no:prglineNo/prg:prgmem参照
{
	lno=ln;

/*//debug
//char* s[16];
for(byte i=0; i<16;  i++) Serial.write(prgDsp[lno][i]);
Serial.println("");
Serial.println(prg[1]);
//*/

	for(byte i=2; i<16;  i++)  prgDsp[lno][i]=0x20;

	prgDsp[lno][0]=0x30+(no/10);					//行番号２桁
	prgDsp[lno][1]=0x30+(no%10);

	cno=2;
	if(prg[0])	set_Nest(prg[0]);					//階層表示セット
									              				
  if(prg[1]<10){												//コマンドセット1-10まで
	  switch(prg[1]){
			case 1:                           	//Gコマンド
				prgDsp[lno][cno++]='G';
      	set_Num2W(1,prg[2]);							//第一引数
      	set_Num2W(1,prg[3]);							//第二引数
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[4]);							//第三引数
      	break;

			case 2:															//Mコマンド
				prgDsp[lno][cno++]='M';
      	set_Num2W(1,prg[2]);            	//第一引数
      	set_Num2W(1,prg[3]); 							//第二引数
      	break;

    	case 3:                           	//Vコマンド
				prgDsp[lno][cno++]='V';
      	set_Num1W(prg[2]);             		//第一引数
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[3]);            	//第二引数
      	break;

    	case 4:                           	//Wコマンド
				prgDsp[lno][cno++]='W';
				prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[2]);            	//第一引数
      	break;

    	case 5:                           	//Lコマンド
				prgDsp[lno][cno++]='L';
      	set_Num1W(prg[2]);              	//第一引数
				prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[3]);            	//第二引数
      	break;

    	case 6:                           	//Oコマンド
				prgDsp[lno][cno++]='O';
      	set_Num1W(prg[2]);              	//第一引数
				prgDsp[lno][cno++]=':';
      	set_Num2W(1,prg[3]);            	//第二引数
      	break;

   		default:                          	//無効コマンド
				prgDsp[lno][cno++]=' ';
		}
	}
  else if(prg[1]<20){										//コマンドセット10-19まで=? v350
		prgDsp[lno][cno++]='?';							//10=?S/11=?C/12=?X/13=?T/14=?I
		prgDsp[lno][cno++]=VARI[prg[1]-10];		//変数名セット

  	set_Num1W(prg[2]);										//第１引数
  	set_KIGO(prg[3]);											//第２引数
		set_Num2W(1,prg[4]);									//第３引数
	}
  else if(prg[1]<30){										//コマンドセット20-29まで=$
		prgDsp[lno][cno++]='$';								//20=$S/21=$C/22=$X/23=$T/24=$I
		prgDsp[lno][cno++]=VARI[prg[1]-20];		//変数名セット

  	set_Num1W(prg[2]);										//第１引数
		prgDsp[lno][cno++]=':';
		set_Num2W(0,prg[3]);									//第２引数
		prgDsp[lno][cno++]=',';
		set_Num2W(0,prg[4]);									//第３引数
	}
  else if(prg[1]<40){										//コマンドセット30-39まで=#
		prgDsp[lno][cno++]='#';								//32=#X /33=#T/
		prgDsp[lno][cno++]=VARI[prg[1]-30];		//変数名セット

	  set_Num1W(prg[2]);										//第１引数
  	set_KIGO(prg[3]);											//第２引数
		set_Num2W(1,prg[4]);									//第３引数
	}
  else if(prg[1]<43){										//40=B /41=JB /42=JN
		if(prg[1]==40){												//40=B /41=JB /42=JN
    	prgDsp[lno][cno++]='B';
  	}else{
    	prgDsp[lno][cno++]='J';
    	if(prg[1]==41)  prgDsp[lno][cno++]='B';
    	else        prgDsp[lno][cno++]='N';
  	}
		prgDsp[lno][cno++]=':';
		set_Num2W(0,prg[2]);									//第一引数
	}
  else if(prg[1]<50){											//43=JLQ/44=JLB/45=JLS/46=JLE v361
   	prgDsp[lno][cno++]='J';												//J+L
   	prgDsp[lno][cno++]='L';												//
		if(prg[1]<45){																//JLQ or JLB
			if(prg[1]==43)	prgDsp[lno][cno++]='Q';			//
			else						prgDsp[lno][cno++]='B';			//	
			prgDsp[lno][cno++]=':';
	  	set_Num2W(0,prg[2]);												//第１引数
  		set_KIGO(prg[3]);														//第２引数
			set_Num2W(0,prg[4]);												//第３引数
			
		}else{																				//JLS or JLE
			if(prg[1]==45)	prgDsp[lno][cno++]='S';			//
			else						prgDsp[lno][cno++]='E';			//	
			prgDsp[lno][cno++]=':';
		}
  }else{																//コマンドセット50-59 #X	v360
		prgDsp[lno][cno++]='#';								//変数
		prgDsp[lno][cno++]='X';								
		set_Num1W(prg[1]%10);									//変数番号セット
		prgDsp[lno][cno++]='=';

	  set_Num2W(0,prg[2]);									//第１引数
  	set_KIGO(prg[3]);											//第２引数
		set_Num2W(0,prg[4]);									//第３引数
	}
	return prgDsp[lno];
}
//------------------------------------------------public
void  NRobDsp::set_prgDsp(byte ln, byte buf[])	//表示データに直接書き込み
{
	for(int i=0; i<16; i++){
		prgDsp[ln][i]=buf[i+1];
	}
}

//------------------------------------------------private
void  NRobDsp::set_Nest(byte lv)				//階層文字セット
{
  byte i,l,w, mask;

  w=lv&0x0F;									//階層データ
  l=(lv&0xF0)>>4;            	//階層レベル
  mask=0x01;
  
  for(i=0; i<l; i++){           //ビット判定して+-セット
    if(w&mask)	prgDsp[lno][i+2]='+';
    else        prgDsp[lno][i+2]='-';
    mask = mask<<1;
  }
  cno=i+2;
}

//------------------------------------------------private
void  NRobDsp::set_Num2W(byte f,byte n)	//数字文字変換  f=0:符号なし/=1:符号付き
{
  byte h,l;
  
  if(n>=200){                   				//変数の時
    n -= 200;
    h = n/10;                     				//10の桁は変数文字
    l = n%10;                     				//1の桁は変数番号
    if(f) prgDsp[lno][cno++]='+';
    prgDsp[lno][cno++]=VARI[h];						//変数名
    prgDsp[lno][cno++]=l+0x30;						//変数番号

  }else{																//数字の時
  
  	if(f){
    	if(n<100) prgDsp[lno][cno++]='+';		//符号
   	 	else      prgDsp[lno][cno++]='-';
 	 	}
  	if(n>=100)  n-=100;										//マイナスの時
  	h=n/10;																//数字2桁変換
  	l=n%10;
  	prgDsp[lno][cno++]=h+0x30;
  	prgDsp[lno][cno++]=l+0x30;
	}
}
//------------------------------------------------private
void  NRobDsp::set_Num1W(byte n)				//数字文字変換 1文字
{
  byte l=n%10;
  prgDsp[lno][cno++]=l+0x30;						//数字1文字
}
//------------------------------------------------private
void  NRobDsp::set_KIGO(byte n)					//算術記号セット
{
  if(n<240){
    n=8;
  }else{
    n -= 240;
    if(n>7)  n=8;
  }
  prgDsp[lno][cno++]=SKIGO[n];
}
//------------------------------------------------

//*** 表示データをプログラムデータに変換　prgDsp->参照配列に			  ************

//------------------------------------------------public
byte*	NRobDsp::chg_DspPrg(byte ln)			//表示データから変換 ln=行番号1or2
{
	byte	y=ln;
	byte	x=0;
	byte	w=0;
  byte	h=0;
  byte	l=0;
  byte	mask=0x01;
	
	prgBuf[0] = chg_dspNum(0, y, x);				//行番号を得る
	x=2;
  while(1){                   						//ネスト階層を調べる
    w = prgDsp[y][x];
    if(w=='+' || w=='-'){     						//階層なら順にセット
      h++;
      if(w=='+') l |= mask;
      mask = mask<<1;
      x++;
    }else{
      break;
    }
  }
	prgBuf[1] = (h<<4)|(l&0x0F);							//階層データをセット

  switch(prgDsp[y][x]){
    case 'G':
      prgBuf[2]=01;
      prgBuf[3]=chg_dspNum(1,y,x+1);
      prgBuf[4]=chg_dspNum(1,y,x+4);
      prgBuf[5]=chg_dspNum(0,y,x+8);
      break;
    case 'M':
      prgBuf[2]=02;
      prgBuf[3]=chg_dspNum(1,y,x+1);
      prgBuf[4]=chg_dspNum(1,y,x+4);
      prgBuf[5]=0;
      break;
    case 'V':
      prgBuf[2]=03;
      prgBuf[3]=prgDsp[y][x+1]-0x30;				//1文字数字に
      prgBuf[4]=chg_dspNum(0,y,x+3);
      prgBuf[5]=0;
      break;
    case 'W':
      prgBuf[2]=04;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;
    case 'L':
      prgBuf[2]=05;
      prgBuf[3]=prgDsp[y][x+1]-0x30;				//1文字数字に
      prgBuf[4]=chg_dspNum(0,y,x+3);
      prgBuf[5]=0;
      break;
    case 'O':														//v351
      prgBuf[2]=06;
      prgBuf[3]=prgDsp[y][x+1]-0x30;				//1文字数字に
      prgBuf[4]=chg_dspNum(1,y,x+3);
      prgBuf[5]=0;
      break;
    case 'B':
      prgBuf[2]=40;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;

    case '?':																//判定命令
			prgBuf[2]=get_VARIno(prgDsp[y][x+1])+10;		//変数記号番号
      prgBuf[3]=prgDsp[y][x+2]-0x30;							//変数番号
			prgBuf[4]=get_KIGOno(prgDsp[y][x+3]);
  		prgBuf[5]=chg_dspNum(1,y,x+4);
      break;

		case '$':																//中間判定
			prgBuf[2]=get_VARIno(prgDsp[y][x+1])+20;		//変数記号番号
      prgBuf[3]=prgDsp[y][x+2]-0x30;							//変数番号
			prgBuf[4]=chg_dspNum(0,y,x+4);;
  		prgBuf[5]=chg_dspNum(0,y,x+7);
      break;

    case '#':																//代入命令						v360
			if(prgDsp[y][x+1]=='T'){							// XとTどちらか
				prgBuf[2]=33;			
      	prgBuf[3]=prgDsp[y][x+2]-0x30;							//変数番号
				prgBuf[4]=get_KIGOno(prgDsp[y][x+3]);
  			prgBuf[5]=chg_dspNum(1,y,x+4);
			}else{
																										//v360
				h = 50;
				if(is_Number(prgDsp[y][x+2]))	l=prgDsp[y][x+2]-0x30;		//#Xのセット
				else													l=1;
				prgBuf[2]=h+l;												//コマンド番号
      	prgBuf[3]=chg_dspNum(0,y,x+4);							
				prgBuf[4]=get_KIGOno(prgDsp[y][x+6]);
  			prgBuf[5]=chg_dspNum(0,y,x+7);
			}
      break;

    case 'J':																//ジャンプ命令
			if(prgDsp[y][x+1]=='L'){								//JL命令					v361
				prgBuf[2]=set_LoopWord(prgDsp[y][x+2]);	//次の文字で
				if(prgBuf[2]<45){												//Q,Bは判定が入る
      		prgBuf[3]=chg_dspNum(0,y,x+4);							
					prgBuf[4]=get_KIGOno(prgDsp[y][x+6]);
  				prgBuf[5]=chg_dspNum(0,y,x+7);
				}else{																	//S,Lはコマンドのみ
      		prgBuf[3]=prgBuf[4]=prgBuf[5]=0;
				}
			}else{
				if(prgDsp[y][x+1]=='N')		prgBuf[2]=42;			//BとNどちらかv351
				else											prgBuf[2]=41;
				prgBuf[3]=chg_dspNum(0,y,x+3);							//(行)番号
      	prgBuf[4]=0;
      	prgBuf[5]=0;
			}
      break;

		default:
      prgBuf[2]=0;
      prgBuf[3]=0;
      prgBuf[4]=0;
      prgBuf[5]=0;
  }
	return prgBuf;
}
//------------------------------------------------private
byte	NRobDsp::set_LoopWord(byte w)								//v361
{
	switch(w){
		case 'Q':	return 43;
		case 'B':	return 44;
		case 'S':	return 45;
		case 'E':	return 46;
		default:	return 45;
	}
}
//------------------------------------------------private
byte	NRobDsp::chg_dspNum(byte f,byte dy,byte dx) //数字文字を変換
                              //f=0:２文字のみ/=1:3文字符号付
{
  byte n=0;

	if(f){																//3文字なら符号確認
		if(prgDsp[dy][dx]=='-')		n=100;
		dx++;
	}
	if(prgDsp[dy][dx]==0x20){
		n=0;
	}else{
		if(is_Number(prgDsp[dy][dx])){ 			//数字データ
			n +=  ((prgDsp[dy][dx]-0x30)*10)+ 		//２桁数字変換
      			(prgDsp[dy][dx+1]-0x30);
		}else{																//変数データ
			n = 200;
			n += (get_VARIno(prgDsp[dy][dx])*10);		//変数記号は10の桁
			n += prgDsp[dy][dx+1]-0x30;								//変数番号は1の桁
		}
	}
  return n;
}

//*** コマンド、記号等[配列]の文字確認と操作								************
//------------------------------------------------private
byte	NRobDsp::get_VARIno(byte w)					//変数番号を得る？
{
	byte n=0;
	
	while(n<6){	//v350
		if(w==VARI[n])	break;
		n++;
	}
	return n;
}
//------------------------------------------------private
byte	NRobDsp::get_NextVARI(int no, int a)	//変数　切替 
																					//no=選択範囲:1=SCXT/0=XTのみ/a=加算数
{
	int i=0;

	i=get_VARIno(chgWord);								//変数番号探して
	i=i+a;																//次を選び

	if(no){																//代入
		if(i<2)   i=3;
		if(i>3)   i=2;
	}else{																//判定
		if(i<0)   i=4;
		if(i>4)   i=0;
	}
	return  VARI[i];
}
//------------------------------------------------private
byte	NRobDsp::get_NextNum_VARI(int m, int i)//数字の切替+変数
{																		// m=選択範囲:9=0-9/13=変数まで範囲/i=加算数
	int no;			//数字の値

	if(chgWord>=0x30 && chgWord<=0x39){		//数字の範囲
		no = (int)(chgWord-0x30);						//
	}else{																//それ以外は
		no = (int)get_VARIno(chgWord)+10 ;	//  SCXTを10～13に
	}

	no = no + i;													//次を選んで

	if(no<0) no=m;												//範囲内で回る
	if(no>m) no=0;

	if(no<10) return((byte)(no+0x30));		//次の文字を返す
	else      return VARI[no-10];
}

//------------------------------------------------private
byte	NRobDsp::get_KIGOno(byte w)        	//算術記号を得る？
{
	byte n=0;
	
	while(n<8){
		if(w==SKIGO[n])	break;
		n++;
	}
	return n+240;
}
//------------------------------------------------private
byte	NRobDsp::get_NextKIGO(int no, int a)//記号切替 no=判定演算/a=加算数
{
							//byte  SKIGO[10]=  {'<','>','!','=','+','-','*','/',' ',' '};

	int i=0;

	i=get_KIGOno(chgWord)-240;						//記号番号探して
	i=i+a;																//次を選び

	switch(no){
		case 0:
			if(i<0) i=3;
			if(i>3) i=0;
			break;
		case 1:
			if(i<3) i=7;
			if(i>7) i=3;
			break;
		case 2:
			if(i<4) i=7;
			if(i>7) i=4;
	}


	if(no){																//演算
		if(i<3) i=7;
		if(i>7) i=3;
	}else{																//判定
		if(i<0) i=3;
		if(i>3) i=0;
	}

	return  SKIGO[i];											//次の記号を返す
}



//------------------------------------------------private
byte	NRobDsp::get_ComNo(byte w)       //コマンドの番号を得る w=コマンド文字
{
  byte i;
  for(i=0; i<COMNum; i++){
    if(w==command[i]) break;
  }
	nowComNo = i;
  return i;
}
//------------------------------------------------private
byte	NRobDsp::get_nextCom(byte up, int a)//次のコマンド選択
{																									//up=上の文字/a=加算数/w=文字
  int i=0;
	int no;
																				//選択範囲を算出(上の行の文字参照)
	if(up=='?'|| up=='$') no=0;							//判定の下　+or- 
	else if(up=='+')			no=1;							//+の下　+~Bすべて
	else if(up=='-')			no=2;							//-の下 -~B +を除く
	else									no=3;							//基本　G~B  +-を除く

  i=get_ComNo(chgWord);									//データ探して
  i=i+a;                                //次を選び

	if(i<comSt[no])  i=comEd[no];					//範囲内で回る
	if(i>comEd[no])  i=comSt[no];

	if(curX>2){ 													//行頭以外ではBコマンド使わない
		if(command[i]=='B'){
			i=i+a;
    }
  }
  return(command[i]);
}
//------------------------------------------------private
byte	NRobDsp::get_nextJump(int c, int a)	//Jコマンドの次の選択		v361
{																									//c=選択種/a=加算数
	byte JW[2][4]=	{	{'B','N','L',' '},				// ２文字目
										{'S','Q','B','E'}};				// ３文字目
	int	mx=c+2;																	//範囲 c=0は3，1は4
	int	i;

	for(i=0; i<mx; i++){								//現在の文字探して
		if(chgWord==JW[c][i])	break;
	}
	//if(i==mx)	i=0;

	i += a;																	//次の文字を選ぶ
	if(i<0)		i=mx;
	if(i>mx)	i=0;

	return(JW[c][i]);												//その文字を返す
}
//*** プログラム編集 - 文字解析 ******************
//------------------------------------------------private
byte	NRobDsp::is_Command(void)					//編集中の文字がコマンド文字か v363
{
	byte ans=0;
	byte i=seek_Command();								//行内のコマンドの位置を探す v363

	if(curX==i){													//レベル直後の文字はコマンド
		ans = 1;
	}else if(curX<(i+3)){									//２文字以上のコマンド
		if(nowComNo==10){										//#の時は
			if(curX==i+1)	ans = 1;						// ２文字目はコマンド
		}
		if(nowComNo==12){										//Jの時は２文字目はコマンド
			if(curX==i+1){										// ２文字目はコマンド
				ans = 1;
			}else if(prgDsp[curY][i+1]=='L'){	// 2文字目Lで３文字目はコマンド
				ans = 1;
			}
		}
	}
	return ans;
}
//------------------------------------------------private
byte	NRobDsp::seek_Command(void)				//コマンド文字の場所を探す v363
{
	int i=2;

	while(prgDsp[curY][i]=='+' || prgDsp[curY][i]=='-'){	//レベル位置を探す
		if(i>6) break;
		i++;
	}
	get_ComNo(prgDsp[curY][i]);						//コマンド番号得る

	return i;
}

//------------------------------------------------private
byte	NRobDsp::is_noEditWord(byte w)		//編集文字でないか？
{
  byte  ans=0;

  if(w==':'){
	  ans=1;
  }else if(w==','){
		ans=1;
	}else{
		seek_Command();											//コマンド文字の場所を探す v363
//		get_forwardCom();											//行のコマンドを調べる　v360
		if(nowComNo==10){											//＃コマンドの時は
  		if(w=='=')  ans=1;									//＝　は編集しない文字
		}
	}

  return ans;
}
//------------------------------------------------private
byte	NRobDsp::is_Number(byte w)				//数字文字か？
{
  if(w>=0x30 && w<=0x39)  return 1;
  else                    return 0;
}


//------------------------------------------------
//*** プログラム編集 - 行解析 ******************
//------------------------------------------------private
byte	NRobDsp::get_dspLen(int l)				//l行のプログラム文字数を返す
{
  int i=0;
  while(i<16){
    if(prgDsp[l][i]==0x20)  break;
    i++;
  }
  return i;
}

//*** モード表示関係  **************************************
//*** メニュー切替　モード表示   ***************************
//---------------------------------------------------------
void	NRobDsp::dsp_modeStr(int no)
{
  int tmp=no*16;

  rob.LCD_clear();
  if(no==0){
    //rob.LCD_print("WAIT");
    rob.LCD_printF(titlWit);

  }else{
    for(int i=0; i<15; i++) rob.LCD_write(pgm_read_byte(modeStr1+(tmp+i)));
    rob.LCD_setCursor(0, 1);
    for(int i=0; i<15; i++) rob.LCD_write(pgm_read_byte(modeStr2+(tmp+i)));
  }
  rob.LCD_noCursor();
}

//*** センサーモニタ   *************************************
//------------------------------------------------
void  NRobDsp::moni_AD_set(void)				//ADモニタベース表示
{
  rob.LCD_clear();                    //モニタ画面表示
  //rob.LCD_print("S1-- S2-- S3--  ");
  rob.LCD_printF(titlMon1);												//v361
  rob.LCD_setCursor(0, 1);
  //rob.LCD_print("S4-- S5-- S6--  ");
  rob.LCD_printF(titlMon2);
}
//------------------------------------------------
void  NRobDsp::moni_AD_loop(void)			//ADモニタ動作中表示
{
  int sx[6]={2,7,12,2,7,12};
  int sy[6]={0,0,0,1,1,1};

  for(int i=0; i<6; i++){       		//表示
		int a=(rob.get_AD(i+1)/10);
		if(a>99)	a=99;
   	rob.dsp_Number2(sx[i], sy[i], a);
  }
}
//------------------------------------------------
void  NRobDsp::moni_Sonar_set(void)		//超音波センサモニタベース表示
{
  rob.LCD_clear();                    	//モニタ画面表示
  rob.LCD_setCursor(0, 0);
  //rob.LCD_print("US S7 --  :");
  rob.LCD_printF(titlMon3);												//v361
	rob.LCD_setCursor(0, 1);
  //rob.LCD_print("US S8 --  :");
  rob.LCD_printF(titlMon4);
}
//------------------------------------------------
void  NRobDsp::moni_Sonar_loop(void)		//超音波センサモニタ動作中表示
{
	int us;

	us=rob.get_US(1);
  if(us>99)  us=99;
  rob.dsp_Number2(6, 0, us);			//表示

	us=rob.get_US(2);
  if(us>99)  us=99;
  rob.dsp_Number2(6, 1, us);
}
//------------------------------------------------
void  NRobDsp::moni_Compas_set(void)		//コンパスモニタベース表示
{
  rob.LCD_clear();                    //モニタ画面表示
  rob.LCD_setCursor(0, 0);
  //rob.LCD_print("COMPASS a --    ");
  rob.LCD_printF(titlMon5);												//v361
  rob.LCD_setCursor(0, 1);
  //rob.LCD_print("COMPASS b --    ");
  rob.LCD_printF(titlMon6);
}
//------------------------------------------------
void  NRobDsp::moni_Servo_set(void)		//サーボ動作テストベース表示
{
  rob.LCD_clear();                //モニタ画面表示
  rob.LCD_setCursor(0, 0);
	//rob.LCD_print("Servo M3  --    ");
  rob.LCD_printF(titlMon7);												//v361
  rob.LCD_setCursor(0, 1);
  //rob.LCD_print("Servo M4  --    ");
  rob.LCD_printF(titlMon8);

	moni_Servo_Act(0,0);									// 初期位置に

  rob.dsp_Number2(10, 0, svp1);
  rob.dsp_Number2(10, 1, svp2);
}
//------------------------------------------------
void  NRobDsp::moni_Servo_loop(void)		//サーボ動作テスト動作中表示
{
	if(rob.in_SW(4)){             				//Left
		moni_Servo_Act(2,-1);

	}
	if(rob.in_SW(3)){             				//Right
		moni_Servo_Act(2,1);
	}
	if(rob.in_SW(2)){											//Up
		moni_Servo_Act(1,1);
	}
	if(rob.in_SW(1)){ 				            //Down
		moni_Servo_Act(1,-1);
	}
}
//------------------------------------------------
void  NRobDsp::moni_Servo_Act(int no, int d)		//サーボ動作
{
	switch(no){
		case 0:
			svp1=svp2=50;													//初期値
			rob.act_ServoAbs(1, (svp1*9)/5);				//180度換算
			while(1){
				rob.loop();
				if(!rob.flgServoAct)	break;					// サーボ動作終わり待つ
			}
  		rob.dsp_Number2(10, 0, svp1);

			rob.act_ServoAbs(2, (svp2*9)/5);				//
			while(1){
				rob.loop();
				if(!rob.flgServoAct)	break;					// サーボ動作終わり待つ
			}
  		rob.dsp_Number2(10, 1, svp2);
			break;
		case 1:																//サーボ１
			if(d>0)		svp1 +=5;									//　位置換え
			else			svp1 -=5;
			if(svp1<0)	svp1=0;
			if(svp1>99)	svp1=99;
			rob.act_ServoDir(1, (svp1*9)/5);		//　動作
  		rob.dsp_Number2(10, 0, svp1);				//　表示
			break;
		case 2:																//サーボ２
			if(d>0)		svp2 +=5;
			else			svp2 -=5;
			if(svp2<0)	svp2=0;
			if(svp2>99)	svp2=99;
			rob.act_ServoDir(2, (svp2*9)/5);
  		rob.dsp_Number2(10, 1, svp2);
			break;
	}
}

//------------------------------------------------
void  NRobDsp::moni_Serial_set(void)		//シリアル通信ベース表示
{
  rob.LCD_clear();											//モニタ画面表示
  rob.LCD_setCursor(0, 0);
  //rob.LCD_print("Waiting PC      ");
  rob.LCD_printF(titlMon9);												//v361

}

//********************************************************************

