/*
	NRob Library
		NRob プログラム表示関係のプログラム
*/
//v361	20221207	ループ命令の追加 JLQ,JLS,JLB,JLE
//v361b	ライブラリ統合
//v363	20230114	SW入力　センサーS0に追加

#ifndef NROBDISP_h
#define NROBDISP_h

#include "NRob.h"

#define COMNum  13      //コマンドの数


class NRobDsp
{
  public:
		NRobDsp(NRob3& nr);
		void	init(byte* p);								//初期化

		void	reDraw(byte no,byte prg[]);		//プログラム再表示(変換して表示)
		byte	edit_Moving(void);						//移動動作中 戻値:<>1 動作変更
		byte	edit_Chging(void);						//変更動作中 戻値:0<>動作終了
		byte	edit_InsDel(void);						//行編集動作中 戻値:1=動作終了

		void	cursor_Home(void);						//カーソルホームへ
		void	adjust_curX(void);						//カーソルX文字ある部分のみ移動

		byte*	chg_PrgDsp(byte ln,byte no,byte prg[]);		//１行変換
		byte*	chg_DspPrg(byte ln);					//表示データから変換 ln=行番号0or1

		void	set_prgDsp(byte ln, byte buf[]);	//表示データに直接書き込み

		void	dsp_modeStr(int no);		//メニュー切替　モード表示
															//センサーモニタ表示
		void  moni_AD_set(void);			//ADモニタベース表示
		void  moni_AD_loop(void);			//ADモニタ動作中表示
		void  moni_Sonar_set(void);		//超音波センサモニタベース表示
		void  moni_Sonar_loop(void);	//超音波センサモニタ動作中表示
		void  moni_Compas_set(void);	//コンパスモニタベース表示
		void  moni_Servo_set(void);		//サーボ動作テストベース表示
		void  moni_Servo_loop(void);	//サーボ動作テスト動作中表示
		void  moni_Serial_set(void);	//シリアル通信ベース表示

	private:
		NRob3& rob;
    		                    //0   1   2   3   4   5   6   7   8   9   0   1
		byte command[COMNum+1]={ '+','-','G','M','V','L','O','W','?','$','#','B','J'};
              		 // 0  1  2  3                 コマンドの選択番号
		byte  comSt[4] = {0, 0, 1, 2};              //コマンド選択範囲
		byte  comEd[4] = {1,12,12,12};
		//  =0;判定の下　 +or- 
		//  =1;+の下　+~J すべて
		//  =2;-の下  -~J +を除く
		//  =3;基本　  G~B +-を除く

	                    //0   1   2   3   4   5   6   7   8   9 
		byte  SKIGO[10]=  {'<','>','!','=','+','-','*','/',' ',' '};
		byte  VARI[10]=   {'S','C','X','T','I','O','L','B',' ',' '};//v350

		byte  prgDsp[3][16];          //表示データ
		byte	prgBuf[6];							//プログラム変換用バッファ
		byte	lno;										//表示データ行(0or1)
		byte	cno;										//表示データ桁(0-15)
		int		curX=0;
		int		curY=0;
		byte	nowComNo;											//現在のコマンド番号
		byte	flgInsDel=0;									//挿入削除フラグ 0=削除/1=挿入/9=初期
		byte	chgWord;											//変更中の文字

		int	svp1;
		int	svp2;

		void	select_Com(int i);						//選択文字書換え　コマンド＋その他
		void	select_NextArg(int no, int a);	//引数選択 v360

		void	cursor_MoveRight(void);				//カーソル移動右
		byte	cursor_MoveLeft(void);				//カーソル移動左
		byte	cursor_MoveUp(void);					//カーソル移動上 
		byte	cursor_MoveDown(void);				//カーソル移動下
		void	setCursor(byte x,byte y);			//カーソル位置のセット

		void	dsp_InsDel(void);							//挿入削除表示 

		void  set_Nest(byte lv);				//階層文字セット
		void  set_Num2W(byte f,byte n);	//数字文字変換  f=0:符号なし/=1:符号付き
		void  set_Num1W(byte n);				//数字文字変換 1文字
		void  set_KIGO(byte n);					//算術記号セット

		byte	set_LoopWord(byte w);								//v361
		byte	chg_dspNum(byte f,byte dy,byte dx); //数字文字を変換

		byte	get_VARIno(byte w);						//変数番号を得る？
		byte	get_NextVARI(int no, int a);		//変数　切替 
		byte	get_NextNum_VARI(int m, int i);	//数字の切替+変数
		byte	get_KIGOno(byte w);						//算術記号を得る？
		byte	get_NextKIGO(int no, int a);		//記号切替 no=判定演算/a=加算数
		byte	get_ComNo(byte w);      			//コマンドの番号を得る w=コマンド文字
		//byte	get_forwardCom(void);					//編集部前の命令語の位置を調べる
		byte	get_nextCom(byte up, int a);	//次のコマンド選択
		byte	get_dspLen(int l);						//l行のプログラム文字数を返す
		byte	get_nextJump(int c, int a);		//Jコマンドの次の選択		v361

		byte	is_Command(void);							//編集中の文字がコマンド文字か v363
		byte	seek_Command(void);						//コマンド文字の場所を探す v363
		//byte	is_Command(byte w);						//コマンド文字か	w=コマンド文字
		//byte	is_Command2(byte w1,byte w0);	//コマンド2文字か	v361
		byte	is_noEditWord(byte w);				//編集文字でないか？
		byte	is_Number(byte w);						//数字文字か？

		void  moni_Servo_Act(int no, int d);		//サーボ動作

};

#endif

//プログラム5バイトを参照で受け、表示2行に変換、編集されたデータは参照5バイトデータで返す
//編集操作大半を受ける



